/* list.c: Various assorted functions for various structures.
 * Copyright (C) 2005 by MusIRCd Development.
 * $Id: list.c,v 1.38 2005/07/19 05:24:19 musirc Exp $
 */

#include "client.h"
#include "list.h"
#include "balloc.h"
#include "memory.h"

static int32_t dlinks_count = 0;
static BlockHeap *dnode_heap;

/* side effects - initializes the dnode BlockHeap */
void
init_dlink_nodes(void)
{
  dnode_heap = BlockHeapCreate("dlink node", sizeof(dlink_node), DNODE_HEAP_SIZE);
}
 
/* make_dlink_node()
 * output	- pointer to new dlink_node
 */
dlink_node *
make_dlink_node(void)
{
  dlink_node *lp = BlockHeapAlloc(dnode_heap);

  ++dlinks_count;

  return(lp);
}

/* inputs	- pointer to dlink_node
 * side effects	- free given dlink_node 
 */
void 
free_dlink_node(dlink_node *ptr)
{
  BlockHeapFree(dnode_heap, ptr);
  --dlinks_count;
}
